/*Exercici 4:
* retiro els fons del nino amb photoshop, select>color range>pick a fons blanc i supr
* afegeixo una papallona al fons
* s'inicia i es passa de l'un a l'altre amb el click ratolí*/

//declaro les variables
//imatges
PImage img;//fons
//imatges moviment nino
PImage ninoParat;
PImage ninoSaltant01;
PImage ninoSaltant02;

//imatges moviment papallona
PImage papallona01;
PImage papallona02;
PImage papallona03;

//faig una array contenidora d'imatges
//pel nino
PImage imgSaltarArray[] = new PImage [3];//número imatges que conté array
//per la papallona
PImage imgPapallonaArray[] = new PImage [3]; //número imatges array

//variables auxiliars
int posX_img; int posY_img; //posició imatge
int posSaltarArray; //valor index array nino
int posPapallonaArray; //valor index array papallona
//increment X i Y nino
int incX;
int incY;

//posició X i Y papallona
int papX;
int papY;
int frame; //valor del frame del guió

void setup () {
  size (800, 331);//poso mida finestra, igual imatge fons
  frameRate (10);//frames per segon
  
  //defineixo variable img i carrego imatge fons
  img = loadImage ("background.jpg");
  
  //defineixo variable i carrego imatge nino de l'array
  imgSaltarArray[0] = loadImage ("parat.png");
  imgSaltarArray[1] = loadImage ("saltant01.png");//defineixo variable i carrego nino saltant01
  imgSaltarArray[2] = loadImage ("saltant02.png");//defineixo variable i carrego nino saltant02
  
  //defineixo variable i carrego imatge papallona de l'array
  imgPapallonaArray[0] = loadImage ("papallona01.png");
  imgPapallonaArray[1] = loadImage ("papallona02.png");
  imgPapallonaArray[2] = loadImage ("papallona03.png");
  
  //inicio variables de posició imatges array
  posX_img = width/2 - imgSaltarArray[0].width/2;
  posY_img = 40; 
  
  //inicio variables auxiliars
  posSaltarArray = 0;
  incX = 10;
  incY = 5;
  //posició inicial papallona
  papX = 0;
  papY = 0;
  frame = 1;
 
}

//descric tot el que dibuixaré

void draw () {
  image (img, 0, 0);//situo la imatge de fons al 0,0
  
  //FUNCIO moviment de la papallona
  //la situo darrera del nino
  //crido la funcio 'movPapallona'
  //rep 'posPapallonaArray' que modifica l'index 
  //a cada pas de cicle per carregar les imatges 
  //de l'array 'imgPapallonaArray'
  papMoviment(posPapallonaArray);
  
  //condicional per controlar l'increment 
  //de la variable 'posPapallonaArray'
  if (posPapallonaArray == imgPapallonaArray.length-1){
    posPapallonaArray = 0;
  }
  else {
    posPapallonaArray++;
  }
  
  //estructura de control SWITCH que verifica quin frame cal mostrar
  switch (frame) {
    //cas1: la variable frame és 1
    //es crida frame1()
    //s'inicia de nou la variables 'posSaltarArray'
    //preparat per l'animació del frame2()
    case 1:
      frame1();
      posSaltarArray = 0;
      break;
    
    //cas2: la variable frame és 2
    //es crida frame2(int) que rep la variable 'posSaltarArray'
    //s'inicia de nou la variables 'posSaltarArray'
    /*modifico index per poder recuperar consecutivament 
    les imatges carregades a l'array imgSaltarArray[]*/
    case 2:
    frame2(posSaltarArray);
    
    //condicional per controlar l'increment de la variable 'posSaltarArray'
    if (posSaltarArray == imgSaltarArray.length-1){
      posSaltarArray = 0;
    }
    else {
      posSaltarArray++;
    }
    break;
  }

 }
 
  
//FUNCIONS

//definició funcio control frame1 parats
void frame1 (){
  //estableixo mètodes i paràmetres de la imatge i el text a mostrar
  image (imgSaltarArray[0], posX_img, posY_img);
  
  fill (0);//color text negre
  textSize (20);//defineixo mida text
  text ("PARATS", 50, 50);//què escric i en quin punt

}

//definició de la funció frame2 saltant
//Per fer l'animació es passa com a paràmetre un número enter 
//que recull l'índex de l'array 
//El valor del paràmetre es modifica a dins de la funció draw();
void frame2 (int posSaltarArray){
  
  //estableixo mètodes i paràmetres de la imatge i el text a mostrar
  image (imgSaltarArray[posSaltarArray], posX_img, posY_img);
  fill (255);//color text blanc  
  text ("SALTANT", 600, 50);// què escric i en quin punt 
}

//funcio que controla el moviment papallona
//per fer l'animacio passem un numero enter com a parametre
//que recull l'index de l'array
//el valor del paràmetre es modifica dins de la funció draw()
void papMoviment (int posPapallonaArray){
  
    //condicional que controla Y del moviment de la papallona
    // si la papallona supera el límit inferior
    //invertim valor de l'increment per fer-la pujar de nou
    if (papY >= height/2){
      incY *= -1;
    }
    
    //condicional que controla Y del moviment de la papallona
    //si la papallona supera el límit superior
    //invertim el valor de l'increment per fer-la baixar i
    // s'inicien coordenades de nou per començar cicle moviment de nou
      if(papY < -50){
    papX = 0;
    papY = 0;
    incY *= -1;
  }
  
  image(imgPapallonaArray[posPapallonaArray], papX+incX, papY+incY);
  papX += incX;
  papY += incY;
}

//funció que controla el click del mouse
void mousePressed() {
  if (frame==1) {
    frame=2;
  } else {
    frame=1;
  }
}

