/*Exercici 3:
* frame 1 text parats, imatge nino parat
* frame 2 text saltant, animacio 3 imatges saltant
* s'inicia i es passa de l'un a l'altre amb el click ratolí*/

//declaro les variables
//imatges
PImage img;//fons
//imatges moviment nino
PImage ninoParat;
PImage ninoSaltant01;
PImage ninoSaltant02;

//faig una array contenidora d'imatges
PImage imgSaltarArray[] = new PImage [3];//número imatges que conté array

//variables auxiliars
int posX_img; int posY_img; //posició imatge
int posSaltarArray; //valor index array
//increment X i Y
int incX;
int incY;

int frame; //valor del frame del guió

void setup () {
  size (800, 331);//poso mida finestra, igual imatge fons
  frameRate (10);//frames per segon
  
  //defineixo variable img i carrego imatge fons
  img = loadImage ("background.jpg");
  //defineixo variable i carrego imatge nino de l'array
  imgSaltarArray[0] = loadImage ("parat.png");
  imgSaltarArray[1] = loadImage ("saltant01.png");//defineixo variable i carrego nino saltant01
  imgSaltarArray[2] = loadImage ("saltant02.png");//defineixo variable i carrego nino saltant02
  
  //inicio variables de posició imatges array
  posX_img = width/2 - imgSaltarArray[0].width/2;
  posY_img = 40; 
  
  //inicio variables auxiliars
  posSaltarArray = 0;
  incX = 10;
  incY = 5;
  frame = 1;
 
}

//descric tot el que dibuixaré

void draw () {
  image (img, 0, 0);//situo la imatge de fons al 0,0
  
  //estructura de control SWITCH que verifica quin frame cal mostrar
  switch (frame) {
    //cas1: la variable frame és 1
    //es crida frame1()
    //s'inicia de nou la variables 'posSaltarArray'
    //preparat per l'animació del frame2()
    case 1:
      frame1();
      posSaltarArray = 0;
      break;
    
    //cas2: la variable frame és 2
    //es crida frame2(int) que rep la variable 'posSaltarArray'
    //s'inicia de nou la variables 'posSaltarArray'
    /*modifico index per poder recuperar consecutivament 
    les imatges carregades a l'array imgSaltarArray[]*/
    case 2:
    frame2(posSaltarArray);
    
    //condicional per controlar l'increment de la variable 'posSaltarArray'
    if (posSaltarArray == imgSaltarArray.length-1){
      posSaltarArray = 0;
    }
    else {
      posSaltarArray++;
    }
    break;
  }
}
  
  
//FUNCIONS

//definició funcio control frame1 parats
void frame1 (){
  //estableixo mètodes i paràmetres de la imatge i el text a mostrar
  image (imgSaltarArray[0], posX_img, posY_img);
  
  fill (0);//color text negre
  textSize (20);//defineixo mida text
  text ("PARATS", 50, 50);//què escric i en quin punt

}

//definició de la funció frame2 saltant
//Per fer l'animació es passa com a paràmetre un número enter 
//que recull l'índex de l'array 
//El valor del paràmetre es modifica a dins de la funció draw();
void frame2 (int posSaltarArray){
  
  //estableixo mètodes i paràmetres de la imatge i el text a mostrar
  image (imgSaltarArray[posSaltarArray], posX_img, posY_img);
  fill (255);//color text blanc  
  text ("SALTANT", 600, 50);// què escric i en quin punt 
}

//funció que controla el click del mouse
void mousePressed() {
  if (frame==1) {
    frame=2;
  } else {
    frame=1;
  }
}

